// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
// GL a GLU kniznica
#include <GL/gl.h>
//#include <GL/glu.h>
// funkcie SDL kniznice
#include <SDL/SDL.h>

// .h subor
#include "mOGL.h"

// konstruktor *************************************************************
mOGL::mOGL()
{
 t_a=0; t_b=0; // pomocne premenne

 StartInfoPos=10.0f; // pozicia vypisu 1. textu pocas startu aplikacie

 lighting_onoff=1; // osvetlenie
 normals_onoff=0;  // normaly
 fog_onoff=0;      // hmla
 help_onoff=0;     // napoveda
 pause_motion=0;   // casovo zavisly pohyb
 SLNBSP_draw_type=0; // vykresluju sa vsetky trojuholniky SLNBSP stromu
	
 scene_roty=0.0f;
}

// destruktor **************************************************************
mOGL::~mOGL()
{

}

// vypis info pocas startu aplikacie ***************************************
void mOGL::PrintStartInfo(char *infotext)
{
 ogl_Text.OpenDrawString();
 ogl_Text.DrawString(10.0f,StartInfoPos,infotext);
 ogl_Text.CloseDrawString();

 // vymena zobrazovacich zasobnikov, zobrazenie sceny
 SDL_GL_SwapBuffers();

 // dalsi text bude vypisany na novu poziciu
 StartInfoPos+=20.0f;
 // pauza aby bol text aspon chvilku viditelny
 SDL_Delay(300);
}

// inicializacia OpenGL - nastavenie parametrov pre tvorbu OpenGL sceny ****
bool mOGL::gl_initialize(void)
{
 // nastavenie 8-mich vseobecnych materialov
 for (t_a=0;t_a<8;t_a++) {
  ogl_Material[t_a].amb[0]=1.0f; ogl_Material[t_a].amb[1]=1.0f;
  ogl_Material[t_a].amb[2]=1.0f; ogl_Material[t_a].amb[3]=1.0f;
  ogl_Material[t_a].dif[0]=0.6f; ogl_Material[t_a].dif[1]=0.6f;
  ogl_Material[t_a].dif[2]=0.6f; ogl_Material[t_a].dif[3]=1.0f;
  ogl_Material[t_a].spe[0]=1.0f; ogl_Material[t_a].spe[1]=1.0f;
  ogl_Material[t_a].spe[2]=1.0f; ogl_Material[t_a].spe[3]=1.0f;
  ogl_Material[t_a].amb_dif[0]=0.25f; ogl_Material[t_a].amb_dif[1]=0.25f;
  ogl_Material[t_a].amb_dif[2]=0.25f; ogl_Material[t_a].amb_dif[3]=1.0f;
  ogl_Material[t_a].emi[0]=0.0f; ogl_Material[t_a].emi[1]=0.0f;
  ogl_Material[t_a].emi[2]=0.0f; ogl_Material[t_a].emi[3]=1.0f;
  ogl_Material[t_a].shi=0.0f;
  ogl_Material[t_a].transp=0.0f;
  ogl_Material[t_a].sillum[0]=0.0f; ogl_Material[t_a].sillum[1]=0.0f;
  ogl_Material[t_a].sillum[2]=0.0f; ogl_Material[t_a].sillum[3]=1.0f;
 }
 // nastavenie 8-mich vseobecnych svetiel
 for (t_a=0;t_a<8;t_a++) {
  ogl_Light[t_a].amb[0]=0.25f; ogl_Light[t_a].amb[1]=0.25f;
  ogl_Light[t_a].amb[2]=0.25f; ogl_Light[t_a].amb[3]=1.0f;
  ogl_Light[t_a].dif[0]=0.5f; ogl_Light[t_a].dif[1]=0.5f;
  ogl_Light[t_a].dif[2]=0.5f; ogl_Light[t_a].dif[3]=1.0f;
  ogl_Light[t_a].spe[0]=0.75f; ogl_Light[t_a].spe[1]=0.75f;
  ogl_Light[t_a].spe[2]=0.75f; ogl_Light[t_a].spe[3]=1.0f;
  ogl_Light[t_a].pos[0]=-2.0f; ogl_Light[t_a].pos[1]=3.0f;
  ogl_Light[t_a].pos[2]=-22.0f; ogl_Light[t_a].pos[3]=1.0f;
  // pos[3]=1.0f - vsesmerove svetlo, 0.0f - smerove svetlo
  ogl_Light[t_a].spot[0]=0.0f;
  ogl_Light[t_a].spot[1]=0.0f;
  ogl_Light[t_a].spot[2]=-1.0f;
 }
 // nastavenie farby hmly
 ogl_FogColor[0]=0.0f; ogl_FogColor[1]=0.0f;
 ogl_FogColor[2]=0.0f; ogl_FogColor[3]=1.0f;

 // STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ --

 // nastavenie OpenGL zasobnika farieb a hlbky *****************************
 glClearColor(0.0f,0.0f,0.0f,0.5f); // zasobnik farieb bude vymazavany ciernou farbou
 glClearDepth(1.0f);                // zasobnik hlbky bude vymazavany nastavenim na 1.0f

 glDepthFunc(GL_LEQUAL);  // typ porovnavacej funkcie pre urcenie z-vzdialenosti
 glEnable(GL_DEPTH_TEST); // zapnutie testovania hlbky

 glDisable(GL_CULL_FACE); // nastavenie poradia, v ktorom budu definovane vrcholy objektu
 glFrontFace(GL_CCW);     // reprezentovat privratene resp. odvratene plochy,
 glCullFace(GL_BACK);     // CCW - proti smeru hod. ruciciek, CW - v smere hod. ruciciek
 glEnable(GL_CULL_FACE);  // odvratene plochy sa nebudu spracovavat

 // nastavenie parametrov 1. OpenGL svetla
 glLightfv(GL_LIGHT0,GL_AMBIENT,ogl_Light[0].amb);
 glLightfv(GL_LIGHT0,GL_DIFFUSE,ogl_Light[0].dif);
 glLightfv(GL_LIGHT0,GL_SPECULAR,ogl_Light[0].spe);
 glLightfv(GL_LIGHT0,GL_POSITION,ogl_Light[0].pos);
 glEnable(GL_LIGHT0);
 if (lighting_onoff) glEnable(GL_LIGHTING);
 else glDisable(GL_LIGHTING);
 // svetlo sa pocita len pre privratene strany
 glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,0);
 // svetelne vypocty su lokalne
 glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_TRUE);

 // vseobecny material objektov
 glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,ogl_Material[0].amb_dif);
 // farba bude mat vplyv iba na 'diffuse' komponent materialu
 glColorMaterial(GL_FRONT,GL_DIFFUSE);
 // pre Gourandove svetelne vypocty bude pouzity material priradeny objektu,
 // ktory bude ale stale ovplyvneny farbou zadavanou prikazom glColor
 glEnable(GL_COLOR_MATERIAL);
 // zapnutie gourand-jemneho tienovania
 glShadeModel(GL_SMOOTH);
 // trojuholniky budu vyplnene
 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

 // realnejsie perspektivne vypocty a korekcie
 glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);

 glFogi(GL_FOG_MODE,GL_EXP2);        // typ hmly
 glFogfv(GL_FOG_COLOR,ogl_FogColor); // farba hmly
 glFogf(GL_FOG_DENSITY,0.05f);       // hustota hmly
 glHint(GL_FOG_HINT,GL_DONT_CARE);   //
 glFogf(GL_FOG_START,2000.0f);       // zaciatok viditelnosti hmly
 glFogf(GL_FOG_END,4000.0f);         // vzdialenost maxima hmly
 if (fog_onoff) glEnable(GL_FOG);    // povolenie hmly

 // zapnutie texturovania
 glEnable(GL_TEXTURE_2D);

 // INICIALIZACIA SCENY INICIALIZACIA SCENY INICIALIZACIA SCENY ------------

 // vymazanie zasobnika farieb a hlbky
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

 // inicializacia vypisovania OpenGL textu
 if (ogl_Text.TextInitialize()) {
  fprintf(stderr,"Chyba inicializacie fontu!\n"); return(1);
 }
 // potvrdenie startu OpenGL
 PrintStartInfo("Nastavenie OpenGL stavoveho stroja...");
 PrintStartInfo("OK");
 // zameriavaci kriz
 PrintStartInfo("Nahratie textury zameriavacieho kriza...");
 if (ogl_Texture.LoadCrosshairTexture("data/gfx/crosshair2.bmp")) {
  fprintf(stderr,"Chyba nahratia textury zameriavacieho kriza!\n"); return(1); 
 }
 PrintStartInfo("OK");

 // nacitanie mapy sceny
 PrintStartInfo("Nacitanie mapy sceny...");
 ogl_SceneMap.OpenMapFile("data/map/room1.map");
 if (ogl_SceneMap.ReadMapData()) {
  fprintf(stderr,"Chyba nacitania mapy sceny!\n"); return(1); 
 }
 // nacitanie vsetkych textur definovanych v mape sceny
 for (t_a=0;t_a<ogl_SceneMap.texcount;t_a++) {
  if (ogl_Triangle.texture_add(t_a,ogl_SceneMap.texfile[t_a])) {
   fprintf(stderr,"Chyba nacitania textur definovanych v mape sceny!\n"); return(1);  
  }
 }

 // vytvorie zoznamu trojuholnikov z nacitanej mapy sceny
 t_b=0;
 for (t_a=0;t_a<ogl_SceneMap.gldata_count;t_a++) {
  ogl_Triangle.triangle_add((GLuint) *(ogl_SceneMap.gldata+t_b+0),
                            *(ogl_SceneMap.gldata+t_b+1),*(ogl_SceneMap.gldata+t_b+2),*(ogl_SceneMap.gldata+t_b+3),
                            *(ogl_SceneMap.gldata+t_b+4),*(ogl_SceneMap.gldata+t_b+5),*(ogl_SceneMap.gldata+t_b+6),
                            *(ogl_SceneMap.gldata+t_b+7),*(ogl_SceneMap.gldata+t_b+8),*(ogl_SceneMap.gldata+t_b+9),
                            *(ogl_SceneMap.gldata+t_b+10),*(ogl_SceneMap.gldata+t_b+11),
                            *(ogl_SceneMap.gldata+t_b+12),*(ogl_SceneMap.gldata+t_b+13),
                            *(ogl_SceneMap.gldata+t_b+14),*(ogl_SceneMap.gldata+t_b+15),
	                        (GLuint) 1);
  t_b+=16;
 }
 ogl_Triangle.map_tris_count=ogl_Triangle.all_tris_count;

 // uvolnenie pamate po nacitani mapy sceny
 ogl_SceneMap.CloseMapFile();
 PrintStartInfo("OK");

 // vytvorenie SLNBSP stromu
 PrintStartInfo("Vytvorenie Solid Leaf Node BSP stromu...");
 if (ogl_Triangle.create_SLNBSPT()) {
  fprintf(stderr,"Chyba pocas tvorby SLNBSP stromu!\n"); return(1);	 
 }
 PrintStartInfo("OK");
 
 // koniec pociatocnych nastaveni, zaciatok interakcie pozorovatela
 PrintStartInfo("START");

 // nastavenie farby a velkosti neskor vypisovaneho textu 
 ogl_Text.SetTextColor(1.0f,0.8f,0.0f);
 ogl_Text.SetTextSize(10);
 
 // nastavenie startovacej farby - biela
 glColor4f(1.0f,1.0f,1.0f,1.0f);
 
 return(0);
}

// vykreslenie OpenGL sceny ************************************************
int mOGL::gl_draw(void)
{
 // vymazanie zasobnika farieb a hlbky
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

 // zresetovanie modelovej matice
 glLoadIdentity();

 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 if (SLNBSP_draw_type==0) glMultMatrixf(ogl_Camera[0].matrix);
 else {
  glRotatef(35.0f,1.0f,0.0f,0.0f);
  glRotatef(-30.0f,0.0f,1.0f,0.0f);
 }

 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 if (SLNBSP_draw_type==0) glTranslatef(ogl_Camera[0].posx,ogl_Camera[0].posy,ogl_Camera[0].posz);
 else glTranslatef(-14.0f,-14.0f,-4.0f);

 // transformacia polohy svetla podla polohy kamery
 //ogl_Light[0].pos[0]=-ogl_Camera[0].posx;
 //ogl_Light[0].pos[1]=-ogl_Camera[0].posy;
 //ogl_Light[0].pos[2]=-ogl_Camera[0].posz;
 // umiestenenie svetla na preddefinovanu poziciu
 glLightfv(GL_LIGHT0,GL_POSITION,ogl_Light[0].pos);

 // ak je zobrazeny SLNBSP strom, modra kocka predstavuje kameru
 if (SLNBSP_draw_type==1) {
  glPushMatrix();
  glTranslatef(-ogl_Camera[0].posx,-ogl_Camera[0].posy,-ogl_Camera[0].posz);
  glTranslatef(-0.1f,-0.1f,-0.1f);
  glDisable(GL_TEXTURE_2D);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glBegin(GL_QUADS);
   glVertex3f(0.0f,0.0f,0.0f); glVertex3f(0.2f,0.0f,0.0f);
   glVertex3f(0.2f,0.2f,0.0f); glVertex3f(0.0f,0.2f,0.0f);
	 
   glVertex3f(0.0f,0.0f,-0.2f); glVertex3f(0.0f,0.0f,0.0f);
   glVertex3f(0.0f,0.2f,0.0f);  glVertex3f(0.0f,0.2f,-0.2f);

   glVertex3f(0.2f,0.0f,0.0f);  glVertex3f(0.2f,0.0f,-0.2f);
   glVertex3f(0.2f,0.2f,-0.2f); glVertex3f(0.2f,0.2f,0.0f);
	 
   glVertex3f(0.0f,0.2f,0.0f);  glVertex3f(0.2f,0.2f,0.0f);
   glVertex3f(0.2f,0.2f,-0.2f); glVertex3f(0.0f,0.2f,-0.2f);
   
   glVertex3f(0.0f,0.0f,-0.2f); glVertex3f(0.2f,0.0f,-0.2f);
   glVertex3f(0.2f,0.0f,0.0f);  glVertex3f(0.0f,0.0f,0.0f);
   
   glVertex3f(0.2f,0.0f,-0.2f); glVertex3f(0.0f,0.0f,-0.2f);
   glVertex3f(0.0f,0.2f,-0.2f); glVertex3f(0.2f,0.2f,-0.2f);
  glEnd();
  glEnable(GL_TEXTURE_2D);
  glPopMatrix();
 }

 // trojuholniky nie su vykreslovane pomocou zoznamu,
 // ale je pouzity SLNBSP strom
 //ogl_Triangle.DrawTriangles();
 //if (normals_onoff) ogl_Triangle.DrawTrianglesNormals(0.25f);
 ogl_Triangle.draw_SLNBSPT(-ogl_Camera[0].posx,
                           -ogl_Camera[0].posy,
						   -ogl_Camera[0].posz,
						   SLNBSP_draw_type);
 
 // vykreslenie zameriavacieho kriza
 ogl_Texture.DrawCrosshair(ogl_Camera[0].scr_w,ogl_Camera[0].scr_h);

 if (help_onoff) {
  // vypis textu - help
  ogl_Text.OpenDrawString();

  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-20.0f, "ESC    ukoncenie aplikacie");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-60.0f, "MYS    rotacia v danom smere a strelba");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-80.0f, "SIPKY  posun dopredu,dozadu,vlavo,vpravo");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-100.0f,"A,Z    posun hore,dole");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-120.0f,"J      skok");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-140.0f,"SHIFT  spomalenie posunu");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-160.0f,"Q,W    rotacia okolo doprednej osi vlavo,vpravo");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-180.0f,"R      reinicializacia pohladu kamery");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-200.0f,"C      zapnutie/vypnutie detekcie kolizii");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-240.0f,"M      vyplnene trojuholniky/iba hrany trojuholnikov");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-260.0f,"L      zapnutie/vypnutie osvetlenia");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-280.0f,"N      zapnutie/vypnutie zobrazenia normal");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-300.0f,"G      zapnutie/vypnutie hmly");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-320.0f,"F      zmena typu hmly");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-340.0f,"T      zapnutie/vypnutie texturovania");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-360.0f,"H      zapnutie/vypnutie zobrazenia helpu");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-380.0f,"P      pauza pre casovo zavisle pohyby");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-420.0f,"SPACE  zmena sposobu vykreslenia SLNBSP stromu");

  ogl_Text.CloseDrawString();
 }
 else {
  // vypis textu - poloha kamery
  ogl_Text.OpenDrawString();

  sprintf(ogl_Text.numberbuf,"x:%6.2f",-ogl_Camera[0].posx);
  ogl_Text.DrawNumber(10.0f,30.0f);
  sprintf(ogl_Text.numberbuf,"y:%6.2f",-ogl_Camera[0].posy);
  ogl_Text.DrawNumber(10.0f,20.0f);
  sprintf(ogl_Text.numberbuf,"z:%6.2f",-ogl_Camera[0].posz);
  ogl_Text.DrawNumber(10.0f,10.0f);

  // vypis textu - pocet obrazkov za sekundu
  sprintf(ogl_Text.numberbuf,"%i fps",(GLuint) ogl_Camera[0].ogl_fps);
  ogl_Text.DrawNumber(10.0f,ogl_Camera[0].scr_h-20.0f);

  // vypis textu - pocty trojuholnikov a uzlov
  sprintf(ogl_Text.numberbuf,"troj. z mapy sceny: %i",ogl_Triangle.map_tris_count);
  ogl_Text.DrawNumber(10.0f,ogl_Camera[0].scr_h-60.0f);
  sprintf(ogl_Text.numberbuf,"uzly BSP stromu: %i",ogl_Triangle.all_nodes_count);
  ogl_Text.DrawNumber(10.0f,ogl_Camera[0].scr_h-80.0f); 
  sprintf(ogl_Text.numberbuf,"troj. z BSP stromu: %i",ogl_Triangle.all_tris_count);
  ogl_Text.DrawNumber(10.0f,ogl_Camera[0].scr_h-100.0f); 

  sprintf(ogl_Text.numberbuf,"pocet testovanych uzlov: %i",ogl_Triangle.tested_nodes);
  ogl_Text.DrawNumber(10.0f,ogl_Camera[0].scr_h-140.0f);

  ogl_Text.CloseDrawString();
 }

 return(0);
}

// casovo zavisla uprava objektov, resp. sceny *****************************
int mOGL::gl_iddle(void)
{
 if (pause_motion==0) {
	 
 }

 return(0);
}

// zmena sposobu zobrazenia objektov ***************************************
void mOGL::change_PolygonMode(void)
{
 glGetIntegerv(GL_POLYGON_MODE,&ogl_State[0]);
 // INFO: vypis nacitaneho stavu
 //fprintf(stderr,"ogl_State=%d\n",ogl_State[0]);

 if (ogl_State[0]==GL_LINE) glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
 else glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

 SDL_Delay(200);
}

// zap/vyp osvetlenia ******************************************************
void mOGL::change_LightingOnOff(void)
{
 if (glIsEnabled(GL_LIGHTING)) glDisable(GL_LIGHTING);
 else glEnable(GL_LIGHTING);

 SDL_Delay(200);
}

// zap/vyp vykreslovania normal ********************************************
void mOGL::change_NormalsOnOff(void)
{
 if (normals_onoff==0) normals_onoff=1;
 else normals_onoff=0;

 SDL_Delay(200);
}

// zap/vyp hmly ************************************************************
void mOGL::change_FogOnOff(void)
{
 if (glIsEnabled(GL_FOG)) glDisable(GL_FOG);
 else glEnable(GL_FOG);

 SDL_Delay(200);
}

// zmena parametrov hmly ***************************************************
void mOGL::change_FogMode(void)
{
 glGetIntegerv(GL_FOG_MODE,&ogl_State[0]);
 // INFO: vypis nacitaneho stavu
 //fprintf(stderr,"ogl_State=%d\n",ogl_State[0]);

 if (ogl_State[0]==GL_EXP) glFogi(GL_FOG_MODE,GL_EXP2);
 else if (ogl_State[0]==GL_EXP2) glFogi(GL_FOG_MODE,GL_LINEAR);
      else glFogi(GL_FOG_MODE,GL_EXP);

 SDL_Delay(200);
}

// zap/vyp texturovania ****************************************************
void mOGL::change_TexOnOff(void)
{
 if (glIsEnabled(GL_TEXTURE_2D)) glDisable(GL_TEXTURE_2D);
 else glEnable(GL_TEXTURE_2D);

 SDL_Delay(200);
}

// zap/vyp vypisu helpu ****************************************************
void mOGL::change_HelpOnOff(void)
{
 if (help_onoff==0) help_onoff=1;
 else help_onoff=0;
 
 SDL_Delay(200);
}

// zap/vyp casovo zavisleho pohybu objektov ********************************
void mOGL::change_PauseMotion(void)
{
 if (pause_motion==0) pause_motion=1;
 else pause_motion=0;
 
 SDL_Delay(200);
}

// zmena sposobu vykreslovania SLNBSP stromu *******************************
void mOGL::change_DrawType(void)
{
 if (SLNBSP_draw_type==0) SLNBSP_draw_type=1;
 else SLNBSP_draw_type=0;
 
 SDL_Delay(200);
}
