// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// GL a GLU kniznica
#include <GL/gl.h>
//#include <GL/glu.h>

// .h subor
#include "mSceneMap.h"

// konstruktor *************************************************************
mSceneMap::mSceneMap()
{
 mapfile=ff;

 gldata=NULL;
 gldata_count=0;

 for (a=0;a<MAP_TEX_NUM;a++) {
  texfile[a]=NULL;
 }
 texcount=0;
}

// destruktor **************************************************************
mSceneMap::~mSceneMap()
{
 CloseMapFile();
}

// otvorenie suboru ********************************************************
void mSceneMap::OpenMapFile(char *fname)
{
 strcpy(mapfile,fname); // jedna sa iba o urcenie mena suboru
}

// nacitanie udajov ********************************************************
int mSceneMap::ReadMapData(void)
{
 CloseMapFile(); // nove nacitanie suboru, zmazu sa predosle udaje

 mf=fopen(mapfile,"r"); // otvorenie suboru
 if (!mf) {
  fprintf(stderr,"Chyba pri otvarani suboru: %s\n",mapfile); return(1);
 }

 // pozn. 'x' urci koniec definicie textur a neskor tiez koniec suboru
 // preskocenie definicie textur
 while (!feof(mf)) {
  fscanf(mf,"%s",fstring); if (!strcmp(fstring,"x")) break;
 }

 // zistenie celkoveho poctu trojuholnikov ulozenych v datovom subore
 gldata_count=0;
 while (!feof(mf)) {
  fscanf(mf,"%s",fstring); if (!strcmp(fstring,"x")) break;
  for (a=0;a<15;a++) fscanf(mf,"%f",&ffloat);
  gldata_count++;
 }
 
 rewind(mf); // naspat na zaciatok suboru
 
 // nacitanie textur
 a=0;
 while (!feof(mf)) {
  fscanf(mf,"%s",fstring); if (!strcmp(fstring,"x")) break;
  texfile[a]=(char *) malloc(128*sizeof(char));
  if (texfile[a]==NULL) {
   fclose(mf);
   fprintf(stderr,"Chyba alokacie pamate pre ulozenie nazvu textury!\n");
   return(1);
  }
  fscanf(mf,"%s",fstring);
  strcpy(texfile[a],fstring);
  a++;
 }
 texcount=a;
 
 // priprava miesta pre udaje jednotlivych trojuholnikov
 gldata=(GLfloat *) malloc(gldata_count*16*sizeof(GLfloat));
 if (gldata==NULL) {
  fclose(mf);
  fprintf(stderr,"Chyba alokacie pamate pre ulozenie udajov trojuholnikov!\n");
  return(1);
 }

 // nacitanie udajov jednotlivych trojuholnikov
 for (a=0;a<(gldata_count*16);a+=16) {
  for (b=0;b<16;b++) fscanf(mf,"%f",(gldata+a+b));
 }
 
 fclose(mf); // zatvorenie suboru
 
 return(0);
}

// zatvorenie suboru *******************************************************
void mSceneMap::CloseMapFile(void)
{
 if (gldata!=NULL) {
  free(gldata); gldata=NULL;
  gldata_count=0;
 }
 for (a=0;a<MAP_TEX_NUM;a++) {
  if (texfile[a]!=NULL) { free(texfile[a]); texfile[a]=NULL; }
 }
 texcount=0;
}
