// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
// GL a GLU kniznica
#include <GL/gl.h>
//#include <GL/glu.h>

// vytvorenie textur pre trojuholniky
#include "mTexture.h"

// matematicke operacie
#include "m3Dmath.h"

// .h subor
#include "mTriangle.h"

m3Dmath my_math; // matematicke operacie

// premenne pre urcenie polohy trojuholnika voci rovine
GLuint Pfront,Pbehind,Pon;  // pocitadla polohy vrcholov
PointPos side1,side2,side3; // poloha 3D bodu voci rovine
m3Dvector P1,P2,P3,PN;      // vrcholy tojuholnika, normala roviny

m3Dvector cam_pos; // poloha kamery

mTexture tri_texture; // textury trojuholnikov

// konstruktor *************************************************************
mTriangle::mTriangle()
{
 map_tris_count=0;  //pocet trojuholnikov nacitany z mapy sceny
 all_tris_count=0;  // celkovy pocet trojuholnikov
 all_nodes_count=0; // celkovy pocet uzlov SLNBSP stromu
	
 m_first_triangle=NULL; // v zozname nie su ziadne trojuholniky
 m_last_triangle=NULL;
	
 draw_type=0;
}

// destruktor **************************************************************
mTriangle::~mTriangle()
{
 /* POZOR!!! pamat sa uvolni pomocou destroy_SLNBSPT!!!
 if (m_first_triangle!=NULL) {
  while (m_first_triangle->next!=NULL) { // zmazanie vsetkych trojuholnikov zo zoznamu
   m_t=m_first_triangle->next;           // okrem posledneho trojuholnika
   delete m_first_triangle;
   m_first_triangle=m_t;
  }
  delete m_first_triangle;               // zmazanie posledneho trojuholnika
  m_first_triangle=NULL;
  m_last_triangle=NULL;
 }
 */
 // POZOR!!! zostava uz iba nastavit premenne na 0 a NULL!!!
 map_tris_count=0;
 all_tris_count=0;
 all_nodes_count=0;

 m_first_triangle=NULL;
 m_last_triangle=NULL;

 // zrusenie Solid Leaf Node BSP stromu
 destroy_SLNBSPT();
}

// pridanie trojuholnika do zoznamu ****************************************
int mTriangle::triangle_add(GLuint tid,
                            GLfloat a1,GLfloat a2,GLfloat a3,
                            GLfloat b1,GLfloat b2,GLfloat b3,
                            GLfloat c1,GLfloat c2,GLfloat c3,
                            GLfloat d1,GLfloat d2,
                            GLfloat e1,GLfloat e2,
                            GLfloat f1,GLfloat f2,
                            GLuint ctested)
{
 if (m_first_triangle==NULL) { // vytvorenie 1. trojuholnika
  m_first_triangle=new _TRIANGLE;
  if (m_first_triangle==NULL) {
   fprintf(stderr,"Chyba pri alokacii pamate pre udaje trojuholnika!\n");
   return(1);
  }
  m_last_triangle=m_first_triangle; // na zaciatku m_last_triangle=m_first_triangle
 }
 else {                        // vytvorenie dalsieho trojuholnika
  m_last_triangle->next=new _TRIANGLE;
  if (m_last_triangle->next==NULL) {
   fprintf(stderr,"Chyba pri alokacii pamate pre udaje trojuholnika!\n");
   return(1);
  }
  m_last_triangle=m_last_triangle->next;
 }

 m_last_triangle->id=all_tris_count;
 m_last_triangle->tex_id=tid;
 m_last_triangle->x1=a1; m_last_triangle->y1=a2; m_last_triangle->z1=a3;
 m_last_triangle->x2=b1; m_last_triangle->y2=b2; m_last_triangle->z2=b3;
 m_last_triangle->x3=c1; m_last_triangle->y3=c2; m_last_triangle->z3=c3;
 // vypocet normaly trojuholnika
 my_math.CalcNormal(a1,a2,a3,
                    b1,b2,b3,
                    c1,c2,c3,
                    &xx,&yy,&zz);
 m_last_triangle->tr_nx=xx; m_last_triangle->tr_ny=yy; m_last_triangle->tr_nz=zz;
 // podla rovnice roviny ax+by+cz+d=0 => d=-(ax+by+cz)
 m_last_triangle->D=-(m_last_triangle->tr_nx*m_last_triangle->x1+
                      m_last_triangle->tr_ny*m_last_triangle->y1+
                      m_last_triangle->tr_nz*m_last_triangle->z1);

 m_last_triangle->xn1=xx; m_last_triangle->yn1=yy; m_last_triangle->zn1=zz;
 m_last_triangle->xn2=xx; m_last_triangle->yn2=yy; m_last_triangle->zn2=zz;
 m_last_triangle->xn3=xx; m_last_triangle->yn3=yy; m_last_triangle->zn3=zz;
 m_last_triangle->xt1=d1; m_last_triangle->yt1=d2;
 m_last_triangle->xt2=e1; m_last_triangle->yt2=e2;
 m_last_triangle->xt3=f1; m_last_triangle->yt3=f2;
 CalcCollisionNormals(); // vypocet normal stran trojuholnika potrebnych pre neskorsi
                         // vypocet kolizie s tymto trojuholnikom
						 
 m_last_triangle->color[0]=1.0f; // farba trojuholnika (iba pre zobrazenie SLNBSP stromu)
 m_last_triangle->color[1]=1.0f;
 m_last_triangle->color[2]=1.0f;
 m_last_triangle->color[3]=1.0f;

 m_last_triangle->collision_tested=ctested;

 m_last_triangle->next=NULL;

 all_tris_count++; // zvysenie celkoveho poctu trojuholnikov

 return(0);
}

// vlozenie noveho trojuholnika do zoznamu pocas tvorby SLNBSP stromu ******
int mTriangle::triangle_insert(_TRIANGLE *newtriangle,
                               GLuint id,
                               GLuint tid,
                               GLfloat a1,GLfloat a2,GLfloat a3,
                               GLfloat b1,GLfloat b2,GLfloat b3,
                               GLfloat c1,GLfloat c2,GLfloat c3,
                               GLfloat d1,GLfloat d2,
                               GLfloat e1,GLfloat e2,
                               GLfloat f1,GLfloat f2,
                               GLuint ctested)
{
 // povodny zoznam m_first_triangle ... m_last_triangle je uz ovplyvneny SLNBSP stromom
 // m_last_triangle sa uz moze pouzit lubovolnym sposobom
 m_last_triangle=newtriangle;

 m_last_triangle->id=id+100;
 m_last_triangle->tex_id=tid;
 m_last_triangle->x1=a1; m_last_triangle->y1=a2; m_last_triangle->z1=a3;
 m_last_triangle->x2=b1; m_last_triangle->y2=b2; m_last_triangle->z2=b3;
 m_last_triangle->x3=c1; m_last_triangle->y3=c2; m_last_triangle->z3=c3;
 // vypocet normaly trojuholnika
 my_math.CalcNormal(a1,a2,a3,
                    b1,b2,b3,
                    c1,c2,c3,
                    &xx,&yy,&zz);
 m_last_triangle->tr_nx=xx; m_last_triangle->tr_ny=yy; m_last_triangle->tr_nz=zz;
 // podla rovnice roviny ax+by+cz+d=0 => d=-(ax+by+cz)
 m_last_triangle->D=-(m_last_triangle->tr_nx*m_last_triangle->x1+
                      m_last_triangle->tr_ny*m_last_triangle->y1+
                      m_last_triangle->tr_nz*m_last_triangle->z1);

 m_last_triangle->xn1=xx; m_last_triangle->yn1=yy; m_last_triangle->zn1=zz;
 m_last_triangle->xn2=xx; m_last_triangle->yn2=yy; m_last_triangle->zn2=zz;
 m_last_triangle->xn3=xx; m_last_triangle->yn3=yy; m_last_triangle->zn3=zz;
 m_last_triangle->xt1=d1; m_last_triangle->yt1=d2;
 m_last_triangle->xt2=e1; m_last_triangle->yt2=e2;
 m_last_triangle->xt3=f1; m_last_triangle->yt3=f2;
 CalcCollisionNormals(); // vypocet normal stran trojuholnika potrebnych pre neskorsi
                         // vypocet kolizie s tymto trojuholnikom
						 
 m_last_triangle->color[0]=1.0f; // farba trojuholnika (iba pre zobrazenie SLNBSP stromu)
 m_last_triangle->color[1]=1.0f;
 m_last_triangle->color[2]=1.0f;
 m_last_triangle->color[3]=1.0f;
 
 m_last_triangle->collision_tested=ctested;

 m_last_triangle->next=NULL;

 all_tris_count++; // zvysenie celkoveho poctu trojuholnikov

 return(0);
}

// vypocet normal stran pre vypocet kolizie ********************************
void mTriangle::CalcCollisionNormals(void)
{
 v21=m_last_triangle->tr_nx; // 2. vektorom pre sucin je vzdy normala trojuholnika
 v22=m_last_triangle->tr_ny;
 v23=m_last_triangle->tr_nz;

 // normala pre 1. stranu trojuholnika
 v11=m_last_triangle->x2-m_last_triangle->x1; // vypocet hodnot 1. vektora
 v12=m_last_triangle->y2-m_last_triangle->y1;
 v13=m_last_triangle->z2-m_last_triangle->z1;

 n1=v12*v23-v13*v22; // vektorovy sucin vektorov
 n2=v13*v21-v11*v23;
 n3=v11*v22-v12*v21;

 // normalizacia normaly
 my_math.NormaliseNormal(n1,n2,n3,&nn1,&nn2,&nn3);
 // vysledok sa ulozi ako jeden z udajov o trojuholniku
 m_last_triangle->tr_cn1=nn1;
 m_last_triangle->tr_cn2=nn2;
 m_last_triangle->tr_cn3=nn3;
 // podla rovnice roviny ax+by+cz+d=0 => d=-(ax+by+cz)
 m_last_triangle->tr_cn4=-(nn1*m_last_triangle->x1+
                           nn2*m_last_triangle->y1+
                           nn3*m_last_triangle->z1);

 // normala pre 2. stranu trojuholnika
 v11=m_last_triangle->x3-m_last_triangle->x2; // vypocet hodnot 1. vektora
 v12=m_last_triangle->y3-m_last_triangle->y2;
 v13=m_last_triangle->z3-m_last_triangle->z2;

 n1=v12*v23-v13*v22; // vektorovy sucin vektorov
 n2=v13*v21-v11*v23;
 n3=v11*v22-v12*v21;

 // normalizacia normaly
 my_math.NormaliseNormal(n1,n2,n3,&nn1,&nn2,&nn3);
 // vysledok sa ulozi ako jeden z udajov o trojuholniku
 m_last_triangle->tr_cn5=nn1;
 m_last_triangle->tr_cn6=nn2;
 m_last_triangle->tr_cn7=nn3;
 // podla rovnice roviny ax+by+cz+d=0 => d=-(ax+by+cz)
 m_last_triangle->tr_cn8=-(nn1*m_last_triangle->x2+
                           nn2*m_last_triangle->y2+
                           nn3*m_last_triangle->z2);

 // normala pre 3. stranu trojuholnika
 v11=m_last_triangle->x1-m_last_triangle->x3; // vypocet hodnot 1. vektora
 v12=m_last_triangle->y1-m_last_triangle->y3;
 v13=m_last_triangle->z1-m_last_triangle->z3;

 n1=v12*v23-v13*v22; // vektorovy sucin vektorov
 n2=v13*v21-v11*v23;
 n3=v11*v22-v12*v21;

 // normalizacia normaly
 my_math.NormaliseNormal(n1,n2,n3,&nn1,&nn2,&nn3);
 // vysledok sa ulozi ako jeden z udajov o trojuholniku
 m_last_triangle->tr_cn9=nn1;
 m_last_triangle->tr_cn10=nn2;
 m_last_triangle->tr_cn11=nn3;
 // podla rovnice roviny ax+by+cz+d=0 => d=-(ax+by+cz)
 m_last_triangle->tr_cn12=-(nn1*m_last_triangle->x3+
                            nn2*m_last_triangle->y3+
                            nn3*m_last_triangle->z3);
}

// vytvorenie OpenGL textur pre trojuholniky *******************************
int mTriangle::texture_add(GLuint id,char *texname)
{
 return(tri_texture.LoadTexture(id,texname,TEXTURE_MIPMAP));
}

// ziskanie odkazu na prvy trojuholnik zo zoznamu trojuholnikov ************
_TRIANGLE *mTriangle::GetFirstTriangle(void)
{
 return m_first_triangle;
}

// vykreslenie trojuholnikov ulozenych v zozname ***************************
void mTriangle::DrawTriangles(void)
{
 last_tex_id=0; // pre pripajanie textur
 glBindTexture(GL_TEXTURE_2D,tri_texture.texture_id[last_tex_id]);

 if (m_first_triangle!=NULL) {
  m_t=m_first_triangle;
  while (m_t!=NULL) {
   if (m_t->tex_id!=111) { // tex_id=111 - objekt sa nekresli
    if (m_t->tex_id!=last_tex_id) {
     last_tex_id=m_t->tex_id;
	 // pokial doslo k zmene textury - pripojenie novej textury
     glBindTexture(GL_TEXTURE_2D,tri_texture.texture_id[last_tex_id]);
    }
    glBegin(GL_TRIANGLES); // trojuholnik
     glTexCoord2f(m_t->xt1,m_t->yt1);
 	 glNormal3f(m_t->xn1,m_t->yn1,m_t->zn1);
     glVertex3f(m_t->x1,m_t->y1,m_t->z1);
	   
     glTexCoord2f(m_t->xt2,m_t->yt2);
	 glNormal3f(m_t->xn2,m_t->yn2,m_t->zn2);
     glVertex3f(m_t->x2,m_t->y2,m_t->z2);

     glTexCoord2f(m_t->xt3,m_t->yt3);
	 glNormal3f(m_t->xn3,m_t->yn3,m_t->zn3);
     glVertex3f(m_t->x3,m_t->y3,m_t->z3);
    glEnd();
   }
   m_t=m_t->next;
  }
 }
}

// vykreslenie normal ******************************************************
void mTriangle::DrawTrianglesNormals(GLfloat size)
{
 if (m_first_triangle!=NULL) {
  glPushAttrib(GL_TEXTURE_BIT|GL_LIGHTING_BIT);
  glDisable(GL_TEXTURE_2D); // vypnutie texturovania
  glDisable(GL_LIGHTING);   // vypnutie osvetlenia
  glBegin(GL_LINES); // ciary
   m_t=m_first_triangle;
   while (m_t!=NULL) {
    if (m_t->tex_id!=111) {
     // vykreslia sa normaly v kazdom vrchole
     glColor4f(1.0f,0.0f,0.0f,1.0f); // cervena farba
     glVertex3f(m_t->x1,m_t->y1,m_t->z1);
     glVertex3f(m_t->x1+m_t->xn1*size,m_t->y1+m_t->yn1*size,m_t->z1+m_t->zn1*size);
     glVertex3f(m_t->x2,m_t->y2,m_t->z2);
     glVertex3f(m_t->x2+m_t->xn2*size,m_t->y2+m_t->yn2*size,m_t->z2+m_t->zn2*size);
     glVertex3f(m_t->x3,m_t->y3,m_t->z3);
     glVertex3f(m_t->x3+m_t->xn3*size,m_t->y3+m_t->yn3*size,m_t->z3+m_t->zn3*size);

     // vykreslia sa normaly stran pre vypocet kolizie
     glColor4f(0.0f,0.0f,1.0f,1.0f); // modra farba
     glVertex3f(m_t->x1,m_t->y1,m_t->z1);
     glVertex3f(m_t->x1+m_t->tr_cn1*size,m_t->y1+m_t->tr_cn2*size,m_t->z1+m_t->tr_cn3*size);
     glVertex3f(m_t->x2,m_t->y2,m_t->z2);
     glVertex3f(m_t->x2+m_t->tr_cn5*size,m_t->y2+m_t->tr_cn6*size,m_t->z2+m_t->tr_cn7*size);
     glVertex3f(m_t->x3,m_t->y3,m_t->z3);
     glVertex3f(m_t->x3+m_t->tr_cn9*size,m_t->y3+m_t->tr_cn10*size,m_t->z3+m_t->tr_cn11*size);
    }
    m_t=m_t->next;
   }
  glEnd();
  glPopAttrib(); // zapnutie osvetlenia a texturovania (obnova atributu)
 }
 glColor4f(1.0f,1.0f,1.0f,1.0f); // iba korekcia farieb
}

// vytvorenie Solid Leaf Node BSP stromu ***********************************
int mTriangle::create_SLNBSPT(void)
{
 SLNBSPT=NULL; // koren Solid Leaf Node BSP stromu
 SLNBSPT=new _SolidLeafNode;
 if (SLNBSPT==NULL) {
  fprintf(stderr,"Chyba pri tvorbe SLNBSPT!\n"); return(1);
 }
 SLNBSPT->splitter=NULL;
 SLNBSPT->front   =NULL;
 SLNBSPT->behind  =NULL;
 SLNBSPT->leaf    =0;
 SLNBSPT->solid   =1;
 all_nodes_count++;

 SLNBSP_error=0;

 BuildSLNBSPT(SLNBSPT,m_first_triangle); // rekurzivna funkcia!!!

 return (SLNBSP_error); // OK=0, chyba=1
}

// vykreslenie Solid Leaf Node BSP stromu **********************************
int mTriangle::draw_SLNBSPT(GLfloat cam_pos_x,
                            GLfloat cam_pos_y,
                            GLfloat cam_pos_z,
                            GLubyte dt)
{
 tested_nodes=0; // pocet uzlov, ktore boli testovane pri prechode SLNBSP stromu

 // poloha kamery
 cam_pos.x=cam_pos_x; cam_pos.y=cam_pos_y; cam_pos.z=cam_pos_z;

 // sposob vykreslenia SLNBSP stromu
 draw_type=dt;

 last_tex_id=0; // pre pripajanie textur
 // na zaciatku je pripojena 1. textura
 glBindTexture(GL_TEXTURE_2D,tri_texture.texture_id[last_tex_id]);

 DrawSLNBSPT(SLNBSPT); // rekurzivna funkcia!!!

 return(0);
}

// zrusenie Solid Leaf Node BSP stromu *************************************
int mTriangle::destroy_SLNBSPT(void)
{
 all_tris_count=0;  // v tomto pripade sa jedna o pocet odstranenych trojuholnikov
 all_nodes_count=0; // v tomto pripade sa jedna o pocet odstranenych uzlov SLNBSP stromu

 KillSLNBSPT(SLNBSPT); // rekurzivna funkcia!!!

 // INFO: celkovy pocet odstranenych trojuholnikov sa
 // musi rovnat poctu trojuholnikov po vytvoreni BSP stromu,
 // celkovy pocet odstranenych uzlov sa musi rovnat poctu uzlov
 // vytvorenych pocas tvorby BSP stromu
 fprintf(stderr,"deleted tris: %i\n",all_tris_count);
 fprintf(stderr,"deleted nodes: %i\n",all_nodes_count);

 return(0);
}

// tvorba BSP - rekurzivna funkcia!!! **************************************
void mTriangle::BuildSLNBSPT(_SolidLeafNode *node,_TRIANGLE *list)
{
 _TRIANGLE *FrontList =NULL; // zoznam "prednych" trojuholnikov
 _TRIANGLE *BehindList=NULL; // zoznam "zadnych" trojuholnikov

 // vyber trojuholnika, ktory bude predstavovat deliacu rovinu
 node->splitter=SelectSplitter(list);

 // INFO: identifikator vybratej deliacej roviny (trojuholnika)
 //fprintf(stderr,"deliaca rovina: %i ",node->splitter->id);

 Split1=NULL; Split2=NULL; Split3=NULL;

 TriList=list;

 while (TriList!=NULL) {
  NextTri=TriList->next; // ulozenie ukazatela na dalsi trojuholnik v zozname

  // postupne sa otestuju vsetky trojuholniky okrem toho, ktory predstavuje
  // deliacu rovinu
  if (TriList!=node->splitter) {
   // urcenie polohy trojuholnika voci rovine
   switch (ClassifyTriangle(node->splitter,TriList)) {
    case TRIPOS_FRONT: // trojuholnik lezi pred rovinou
     TriList->next=FrontList;
     FrontList    =TriList;

     // INFO: identifikator trojuholnika
     //fprintf(stderr,"F%i ",TriList->id);
     break;
    case TRIPOS_BEHIND: // trojuholnik lezi za rovinou
     TriList->next=BehindList;
     BehindList   =TriList;

     // INFO: identifikator trojuholnika
     //fprintf(stderr,"B%i ",TriList->id);
     break;
	case TRIPOS_ON: // trojuholnik lezi v rovine - ulozi sa do zoznamu "prednych" trojuholnikov
     TriList->next=FrontList;
     FrontList    =TriList;

     // INFO: identifikator trojuholnika
     //fprintf(stderr,"O%i ",TriList->id);
	 break;
    case TRIPOS_SPANNING: // trojuholnik lezi na oboch stranach roviny - rozdeli sa
     Split1=new _TRIANGLE; Split2=new _TRIANGLE; Split3=new _TRIANGLE;
	 if ((Split1==NULL)||(Split2==NULL)||(Split3==NULL)) SLNBSP_error=1;

	 // INFO: identifikator rozdeleneho trojuholnika
     //fprintf(stderr,"D%i ",TriList->id);

     switch (SplitTriangle(node->splitter,TriList,Split1,Split2,Split3)) {
	  case 0: // BEHIND BEHIND FRONT
	   Split1->next=BehindList; BehindList=Split1;
       Split2->next=BehindList; BehindList=Split2;
       Split3->next=FrontList;  FrontList =Split3;
	   // INFO: typ rozdelenia
       //fprintf(stderr,"BBF ");
	   break;
      case 1: // BEHIND FRONT FRONT
 	   Split1->next=BehindList; BehindList=Split1;
       Split2->next=FrontList;  FrontList =Split2;
       Split3->next=FrontList;  FrontList =Split3;
	   // INFO: typ rozdelenia
       //fprintf(stderr,"BFF ");
       break;
	  case 2: // BEHIND FRONT
	   Split1->next=BehindList; BehindList=Split1;
       Split2->next=FrontList;  FrontList =Split2;
	   delete Split3; // 3. cast sa nevytvorila
	   // INFO: typ rozdelenia
       //fprintf(stderr,"BF ");
       break;
	  case 3: // FRONT FRONT BEHIND
	   Split1->next=FrontList;  FrontList =Split1;
       Split2->next=FrontList;  FrontList =Split2;
       Split3->next=BehindList; BehindList=Split3;
	   // INFO: typ rozdelenia
       //fprintf(stderr,"FFB ");
	   break;
      case 4: // FRONT BEHIND BEHIND
 	   Split1->next=FrontList;  FrontList =Split1;
       Split2->next=BehindList; BehindList=Split2;
       Split3->next=BehindList; BehindList=Split3;
	   // INFO: typ rozdelenia
       //fprintf(stderr,"FBB ");
       break;
	  case 5: // FRONT BEHIND
	   Split1->next=FrontList;  FrontList =Split1;
       Split2->next=BehindList; BehindList=Split2;
	   delete Split3; // 3. cast sa nevytvorila
	   // INFO: typ rozdelenia
       //fprintf(stderr,"FB ");
	   break;
	  default:
	   break;
     }
	 // povodny trojuholnik sa odstrani
     delete TriList;
     // znizenie poctu trojuholnikov o 1 - povodny trojuholnik
     all_tris_count--;
	 // trojuholnik predstavujuci deliacu rovinu bude mat cervenu farbu
	 node->splitter->color[0]=1.0f;
	 node->splitter->color[1]=0.0f;
     node->splitter->color[2]=0.0f;
	 
     break; // koniec TRIPOS_SPANNING
    default:
     break;
   }
  }
  
  TriList=NextTri; // testuje sa dalsi trojuholnik v zozname
 }

 // INFO: novy riadok
 //fprintf(stderr,"\n");
 
 if (FrontList==NULL) {
  // ak je zoznam "prednych" trojuholnikov prazdny, uzol sa oznaci ako Leaf
  node->front=NULL;
  node->leaf=1;
  node->solid=0;
 }
 else {
  // v opacnom pripade sa vytvori Solid uzol stromu a pokracuje sa
  // v spracovavani trojuholnikov ulozenych v zozname "prednych" trojuholnikov
  _SolidLeafNode *newnode=new _SolidLeafNode;
  if (newnode==NULL) SLNBSP_error=1;
  newnode->splitter=NULL;
  newnode->front   =NULL;
  newnode->behind  =NULL;
  newnode->leaf    =0;
  newnode->solid   =1;
  all_nodes_count++;

  node->front=newnode;

  BuildSLNBSPT(newnode,FrontList); // REKURZIA!!!
 }

 if (BehindList==NULL) {
  // ak je zoznam "zadnych" trojuholnikov prazdny, uzol sa oznaci ako Leaf
  node->behind=NULL;
  node->leaf=1;
  node->solid=0;
 }
 else {
  // v opacnom pripade sa vytvori Solid uzol stromu a pokracuje sa
  // v spracovavani trojuholnikov ulozenych v zozname "zadnych" trojuholnikov
  _SolidLeafNode *newnode=new _SolidLeafNode;
  if (newnode==NULL) SLNBSP_error=1;
  newnode->splitter=NULL;
  newnode->front   =NULL;
  newnode->behind  =NULL;
  newnode->leaf    =0;
  newnode->solid   =1;
  all_nodes_count++;

  node->behind=newnode;

  BuildSLNBSPT(newnode,BehindList); // REKURZIA!!!
 }
}

// zrusenie BSP - rekurzivna funkcia!!! ************************************
void mTriangle::KillSLNBSPT(_SolidLeafNode *node)
{
 if (node->front!=NULL) KillSLNBSPT(node->front); // REKURZIA!!!

 if (node->behind!=NULL) KillSLNBSPT(node->behind); // REKURZIA!!!

 if (node->splitter!=NULL) { // odstranenie trojuholnika
  delete node->splitter; node->splitter=NULL;
  all_tris_count++;
 }

 delete node; node=NULL; // odstranenie uzlu SLNBSP stromu
 all_nodes_count++;
}

// vyber trojuholnika, ktory bude predstavovat deliacu rovinu **************
_TRIANGLE *mTriangle::SelectSplitter(_TRIANGLE *list)
{
 _TRIANGLE *splitter=list;
 _TRIANGLE *CurrentTri=NULL;
 _TRIANGLE *SelectedTri=NULL;

 GLint BestScore=100000; // zacne sa s maximalnym skorem
 GLint Score;            // aktualne skore
 GLint Splits;           // pocet nutnych deleni trojuholnikov
 GLint BehindTri;        // pocet "prednych" trojuholnikov
 GLint FrontTri;         // pocet "zadnych" trojuholnikov
 int cl;                 // poloha trojuholnika voci deliacej rovine

 // test vsetkych trojuholnikov v zozname
 while (splitter!=NULL) {
  CurrentTri=list;
  Score    =0;
  Splits   =0;
  BehindTri=0;
  FrontTri =0;

  while (CurrentTri!=NULL) {
   if (CurrentTri!=splitter) {
	// zistenie polohy trojuholnika voci testovanemu trojuholniku
    cl=ClassifyTriangle(splitter,CurrentTri);
    switch (cl) {
     case TRIPOS_FRONT:
      FrontTri++;  // pred
      break;
     case TRIPOS_BEHIND:
      BehindTri++; // za
      break;
     case TRIPOS_ON:
      break;
     case TRIPOS_SPANNING:
      Splits++;    // na oboch stranach - nutne delit
      break;
     default:
      break;
    }
   }
   CurrentTri=CurrentTri->next; // skontroluju sa vsetky trojuholniky v zozname
  }
  // vypocet skore
  Score=abs(FrontTri-BehindTri)+Splits;
  // trojuholnik s lepsim skorem sa vyberie ako buduca deliaca rovina
  if (Score<BestScore) {
   BestScore=Score;
   SelectedTri=splitter;
  }
  
  splitter=splitter->next; // pokracuje sa v urcovani skore pre dalsi trojuholnik
 }
 
 return SelectedTri;
}

// urcenie polohy trojuholnika voci rovine *********************************
int mTriangle::ClassifyTriangle(_TRIANGLE *plane,_TRIANGLE *triangle)
{
 // P1,P2,P3 - vrcholy trojuholnika
 P1.x=triangle->x1; P1.y=triangle->y1; P1.z=triangle->z1;
 P2.x=triangle->x2; P2.y=triangle->y2; P2.z=triangle->z2;
 P3.x=triangle->x3; P3.y=triangle->y3; P3.z=triangle->z3;
 // PN - normala roviny
 PN.x=plane->tr_nx; PN.y=plane->tr_ny; PN.z=plane->tr_nz;
 // side1,side2,side3 - poloha vrcholu P1,P2,P3 voci rovine
 side1=my_math.ClassifyPoint(PN,plane->D,P1);
 side2=my_math.ClassifyPoint(PN,plane->D,P2);
 side3=my_math.ClassifyPoint(PN,plane->D,P3);

 Pfront=0; Pbehind=0; Pon=0;

 // urcenie poctu vrcholov leziacich 'pred', 'za', alebo 'v' rovine
 if (side1==POINTPOS_FRONT) Pfront++;
 else if (side1==POINTPOS_BEHIND) Pbehind++;
	  else { Pon++; Pfront++; Pbehind++; }
 if (side2==POINTPOS_FRONT) Pfront++;
 else if (side2==POINTPOS_BEHIND) Pbehind++;
	  else { Pon++; Pfront++; Pbehind++; }
 if (side3==POINTPOS_FRONT) Pfront++;
 else if (side3==POINTPOS_BEHIND) Pbehind++;
	  else { Pon++; Pfront++; Pbehind++; }

 if (Pon==3) return(TRIPOS_ON);                   // trojuholnik lezi 'v' rovine
 else if (Pfront==3) return(TRIPOS_FRONT);        // trojuholnik lezi 'pred' rovinou
	  else if (Pbehind==3) return(TRIPOS_BEHIND); // trojuholnik lezi 'za' rovinou
		   else return(TRIPOS_SPANNING);          // trojuholnik lezi na oboch stranach roviny
}

// rozdelenie trojuholnika na 2, resp. 3 casti *****************************
int mTriangle::SplitTriangle(_TRIANGLE *plane,
                             _TRIANGLE *tri,
                             _TRIANGLE *split1,_TRIANGLE *split2,_TRIANGLE *split3)
{
 m3Dvector IP1,IP2;     // priesecniky trojuholnika a deliacej roviny
 m3Dvector IP1T,IP2T;   // nove texturovacie suradnice v priesecnikoch
 m3Dvector TT1,TT2,TT3; // texturovacie suradnice povodneho trojuholnika

 // P1,P2,P3 - vrcholy povodneho trojuholnika
 P1.x=tri->x1; P1.y=tri->y1; P1.z=tri->z1;
 P2.x=tri->x2; P2.y=tri->y2; P2.z=tri->z2;
 P3.x=tri->x3; P3.y=tri->y3; P3.z=tri->z3;
 // PN - normala deliacej roviny
 PN.x=plane->tr_nx; PN.y=plane->tr_ny; PN.z=plane->tr_nz;
 // side1,side2,side3 - poloha vrcholu P1,P2,P3 voci deliacej rovine
 side1=my_math.ClassifyPoint(PN,plane->D,P1);
 side2=my_math.ClassifyPoint(PN,plane->D,P2);
 side3=my_math.ClassifyPoint(PN,plane->D,P3);
 // texturovacie suradnice povodneho trojuholnika
 TT1.x=tri->xt1; TT1.y=tri->yt1;
 TT2.x=tri->xt2; TT2.y=tri->yt2;
 TT3.x=tri->xt3; TT3.y=tri->yt3;

 // deliaca rovina pretina P1->P2 hranu povodneho trojuholnika
 if (my_math.EdgePlaneIntersection(P1,P2,PN,plane->D,&IP1)) {
  // P1 a P2 su na opacnych stranach deliacej roviny
  if ((side1!=side2)&&(side3==side2)) {
   // deliaca rovina pretina P1->P3 hranu povodneho trojuholnika
   if (my_math.EdgePlaneIntersection(P1,P3,PN,plane->D,&IP2)) {

    // vypocet novych texturovacich suradnic
	my_math.ComputeTextureCoords(P1,P2,P3,TT1,TT2,TT3,1,3,IP1,IP2,&IP1T,&IP2T);

	// P1,IP1,IP2 budu vrcholy 1. noveho trojuholnika
	triangle_insert(split1,
	                tri->id,
	                tri->tex_id,
	                P1.x,P1.y,P1.z,
	                IP1.x,IP1.y,IP1.z,
	                IP2.x,IP2.y,IP2.z,
	                tri->xt1,tri->yt1,
	                IP1T.x,IP1T.y,
	                IP2T.x,IP2T.y,
	                tri->collision_tested);
	// IP1,P2,IP2 budu vrcholy 2. noveho trojuholnika
	triangle_insert(split2,
	                tri->id,
	                tri->tex_id,
	                IP1.x,IP1.y,IP1.z,
	                P2.x,P2.y,P2.z,
	                IP2.x,IP2.y,IP2.z,
	                IP1T.x,IP1T.y,
	                tri->xt2,tri->yt2,
	                IP2T.x,IP2T.y,
	                tri->collision_tested);
	// P2,P3,IP2 budu vrcholy 3. noveho trojuholnika
	triangle_insert(split3,
	                tri->id,
	                tri->tex_id,
	                P2.x,P2.y,P2.z,
	                P3.x,P3.y,P3.z,
	                IP2.x,IP2.y,IP2.z,
	                tri->xt2,tri->yt2,
	                tri->xt3,tri->yt3,
	                IP2T.x,IP2T.y,
	                tri->collision_tested);

    if (side1==POINTPOS_BEHIND) return(1); // BEHIND FRONT FRONT
	else return(4); // FRONT BEHIND BEHIND
   }
  }    // P1 a P2 su na opacnych stranach deliacej roviny
  else if ((side1!=side2)&&(side3==POINTPOS_ON)) {	  
	    // deliaca rovina prechadza vrcholom P3 povodneho trojuholnika
	    IP2=P3;
	  
	    // vypocet novych texturovacich suradnic
	    my_math.ComputeTextureCoords(P1,P2,P3,TT1,TT2,TT3,1,3,IP1,IP2,&IP1T,&IP2T);

	    // P1,IP1,P3 budu vrcholy 1. noveho trojuholnika
	    triangle_insert(split1,
	                    tri->id,
	                    tri->tex_id,
	                    P1.x,P1.y,P1.z,
	                    IP1.x,IP1.y,IP1.z,
	                    P3.x,P3.y,P3.z,
	                    tri->xt1,tri->yt1,
	                    IP1T.x,IP1T.y,
	                    tri->xt3,tri->yt3,
	                    tri->collision_tested);
	    // IP1,P2,P3 budu vrcholy 2. noveho trojuholnika
        triangle_insert(split2,
	                    tri->id,
	                    tri->tex_id,
	                    IP1.x,IP1.y,IP1.z,
	                    P2.x,P2.y,P2.z,
	                    P3.x,P3.y,P3.z,
	                    IP1T.x,IP1T.y,
	                    tri->xt2,tri->yt2,
	                    tri->xt3,tri->yt3,
	                    tri->collision_tested);
	    // vzniknu iba 2 nove trojuholniky
	    split3=NULL;

        if (side1==POINTPOS_BEHIND) return(2); // BEHIND FRONT
		else return(5); // FRONT BEHIND
       }    // P1 a P2 su na opacnych stranach deliacej roviny
       else if ((side1!=side2)&&(side3==side1)) {
		     // deliaca rovina pretina P2->P3 hranu povodneho trojuholnika
             if (my_math.EdgePlaneIntersection(P2,P3,PN,plane->D,&IP2)) {
				 
			  // vypocet novych texturovacich suradnic   
              my_math.ComputeTextureCoords(P1,P2,P3,TT1,TT2,TT3,1,2,IP1,IP2,&IP1T,&IP2T);

	          // P1,IP2,P3 budu vrcholy 1. noveho trojuholnika
              triangle_insert(split1,
	                          tri->id,
	                          tri->tex_id,
	                          P1.x,P1.y,P1.z,
	                          IP2.x,IP2.y,IP2.z,
	                          P3.x,P3.y,P3.z,
	                          tri->xt1,tri->yt1,
	                          IP2T.x,IP2T.y,
	                          tri->xt3,tri->yt3,
	                          tri->collision_tested);
	          // P1,IP1,IP2 budu vrcholy 2. noveho trojuholnika
              triangle_insert(split2,
	                          tri->id,
	                          tri->tex_id,
	                          P1.x,P1.y,P1.z,
	                          IP1.x,IP1.y,IP1.z,
	                          IP2.x,IP2.y,IP2.z,
	                          tri->xt1,tri->yt1,
	                          IP1T.x,IP1T.y,
	                          IP2T.x,IP2T.y,
	                          tri->collision_tested);
	          // IP1,P2,IP2 budu vrcholy 3. noveho trojuholnika
              triangle_insert(split3,
	                          tri->id,
	                          tri->tex_id,
	                          IP1.x,IP1.y,IP1.z,
	                          P2.x,P2.y,P2.z,
	                          IP2.x,IP2.y,IP2.z,
	                          IP1T.x,IP1T.y,
	                          tri->xt2,tri->yt2,
	                          IP2T.x,IP2T.y,
	                          tri->collision_tested);

			  if (side1==POINTPOS_BEHIND) return(0); // BEHIND BEHIND FRONT
	          else return(3); // FRONT FRONT BEHIND
             }
		    }
 }

 // deliaca rovina pretina P2->P3 hranu povodneho trojuholnika
 if (my_math.EdgePlaneIntersection(P2,P3,PN,plane->D,&IP1)) {
  // P2 a P3 su na opacnych stranach deliacej roviny
  if ((side2!=side3)&&(side1==side3)) {
   // deliaca rovina pretina P1->P2 hranu povodneho trojuholnika
   if (my_math.EdgePlaneIntersection(P1,P2,PN,plane->D,&IP2)) {

    // vypocet novych texturovacich suradnic   
    my_math.ComputeTextureCoords(P1,P2,P3,TT1,TT2,TT3,2,1,IP1,IP2,&IP1T,&IP2T);

	// IP2,P2,IP1 budu vrcholy 1. noveho trojuholnika
	triangle_insert(split1,
	                tri->id,
	                tri->tex_id,
	                IP2.x,IP2.y,IP2.z,
	                P2.x,P2.y,P2.z,
	                IP1.x,IP1.y,IP1.z,
	                IP2T.x,IP2T.y,
	                tri->xt2,tri->yt2,
	                IP1T.x,IP1T.y,
	                tri->collision_tested);
	// P1,IP1,P3 budu vrcholy 2. noveho trojuholnika 
	triangle_insert(split2,
	                tri->id,
	                tri->tex_id,
	                P1.x,P1.y,P1.z,
	                IP1.x,IP1.y,IP1.z,
	                P3.x,P3.y,P3.z,
	                tri->xt1,tri->yt1,
	                IP1T.x,IP1T.y,
	                tri->xt3,tri->yt3,
	                tri->collision_tested);
	// P1,IP2,IP1 budu vrcholy 3. noveho trojuholnika
	triangle_insert(split3,
	                tri->id,
	                tri->tex_id,
	                P1.x,P1.y,P1.z,
	                IP2.x,IP2.y,IP2.z,
	                IP1.x,IP1.y,IP1.z,
	                tri->xt1,tri->yt1,
	                IP2T.x,IP2T.y,
	                IP1T.x,IP1T.y,
	                tri->collision_tested);

    if (side2==POINTPOS_BEHIND) return(1); // BEHIND FRONT FRONT
	else return(4); // FRONT BEHIND BEHIND
   }
  }    // P2 a P3 su na opacnych stranach deliacej roviny
  else if ((side2!=side3)&&(side1==POINTPOS_ON)) {
	    // deliaca rovina prechadza vrcholom P1 povodneho trojuholnika
	    IP2=P1;
	  
	    // vypocet novych texturovacich suradnic   
        my_math.ComputeTextureCoords(P1,P2,P3,TT1,TT2,TT3,2,1,IP1,IP2,&IP1T,&IP2T);
	  
	    // P1,P2,IP1 budu vrcholy 1. noveho trojuholnika
        triangle_insert(split1,
	                    tri->id,
	                    tri->tex_id,
	                    P1.x,P1.y,P1.z,
	                    P2.x,P2.y,P2.z,
	                    IP1.x,IP1.y,IP1.z,
	                    tri->xt1,tri->yt1,
	                    tri->xt2,tri->yt2,
	                    IP1T.x,IP1T.y,
	                    tri->collision_tested);
	    // P1,IP1,P3 budu vrcholy 2. noveho trojuholnika
	    triangle_insert(split2,
	                    tri->id,
	                    tri->tex_id,
	                    P1.x,P1.y,P1.z,
	                    IP1.x,IP1.y,IP1.z,
	                    P3.x,P3.y,P3.z,
	                    tri->xt1,tri->yt1,
	                    IP1T.x,IP1T.y,
	                    tri->xt3,tri->yt3,
	                    tri->collision_tested);
	    // vzniknu iba 2 nove trojuholniky
	    split3=NULL;

        if (side2==POINTPOS_BEHIND) return(2); // BEHIND FRONT
		else return(5); // FRONT BEHIND
       }    // P2 a P3 su na opacnych stranach deliacej roviny
       else if ((side2!=side3)&&(side1==side2)) {
		     // deliaca rovina pretina P1->P3 hranu povodneho trojuholnika
             if (my_math.EdgePlaneIntersection(P1,P3,PN,plane->D,&IP2)) {
				 
		      // vypocet novych texturovacich suradnic   
              my_math.ComputeTextureCoords(P1,P2,P3,TT1,TT2,TT3,2,3,IP1,IP2,&IP1T,&IP2T);
				 
			  // P1,IP1,IP2 budu vrcholy 1. noveho trojuholnika
              triangle_insert(split1,
	                          tri->id,
	                          tri->tex_id,
	                          P1.x,P1.y,P1.z,
	                          IP1.x,IP1.y,IP1.z,
	                          IP2.x,IP2.y,IP2.z,
	                          tri->xt1,tri->yt1,
	                          IP1T.x,IP1T.y,
	                          IP2T.x,IP2T.y,
	                          tri->collision_tested);
	          // P1,P2,IP1 budu vrcholy 2. noveho trojuholnika
              triangle_insert(split2,
	                          tri->id,
	                          tri->tex_id,
	                          P1.x,P1.y,P1.z,
	                          P2.x,P2.y,P2.z,
	                          IP1.x,IP1.y,IP1.z,
	                          tri->xt1,tri->yt1,
	                          tri->xt2,tri->yt2,
	                          IP1T.x,IP1T.y,
	                          tri->collision_tested);
	          // IP2,IP1,P3 budu vrcholy 3. noveho trojuholnika
              triangle_insert(split3,
	                          tri->id,
	                          tri->tex_id,
	                          IP2.x,IP2.y,IP2.z,
	                          IP1.x,IP1.y,IP1.z,
	                          P3.x,P3.y,P3.z,
	                          IP2T.x,IP2T.y,
	                          IP1T.x,IP1T.y,
	                          tri->xt3,tri->yt3,
	                          tri->collision_tested);
							  
              if (side2==POINTPOS_BEHIND) return(0); // BEHIND BEHIND FRONT
	          else return(3); // FRONT FRONT BEHIND
             }
		    }
 }

 // deliaca rovina pretina P1->P3 hranu povodneho trojuholnika
 if (my_math.EdgePlaneIntersection(P1,P3,PN,plane->D,&IP1)) {
  // P1 a P3 su na opacnych stranach deliacej roviny
  if ((side1!=side3)&&(side2==side3)) {
   // deliaca rovina pretina P1->P2 hranu povodneho trojuholnika
   if (my_math.EdgePlaneIntersection(P1,P2,PN,plane->D,&IP2)) {
	   
    // vypocet novych texturovacich suradnic   
    my_math.ComputeTextureCoords(P1,P2,P3,TT1,TT2,TT3,3,1,IP1,IP2,&IP1T,&IP2T);

	// P1,IP2,IP1 budu vrcholy 1. noveho trojuholnika
	triangle_insert(split1,
	                tri->id,
	                tri->tex_id,
	                P1.x,P1.y,P1.z,
	                IP2.x,IP2.y,IP2.z,
	                IP1.x,IP1.y,IP1.z,
	                tri->xt1,tri->yt1,
	                IP2T.x,IP2T.y,
	                IP1T.x,IP1T.y,
	                tri->collision_tested);
	// IP2,P2,IP1 budu vrcholy 2. noveho trojuholnika
	triangle_insert(split2,
	                tri->id,
	                tri->tex_id,
	                IP2.x,IP2.y,IP2.z,
	                P2.x,P2.y,P2.z,
	                IP1.x,IP1.y,IP1.z,
	                IP2T.x,IP2T.y,
	                tri->xt2,tri->yt2,
	                IP1T.x,IP1T.y,
	                tri->collision_tested);
	// IP1,P2,P3 budu vrcholy 3. noveho trojuholnika
	triangle_insert(split3,
	                tri->id,
	                tri->tex_id,
	                IP1.x,IP1.y,IP1.z,
	                P2.x,P2.y,P2.z,
	                P3.x,P3.y,P3.z,
	                IP1T.x,IP1T.y,
	                tri->xt2,tri->yt2,
	                tri->xt3,tri->yt3,
	                tri->collision_tested);

    if (side1==POINTPOS_BEHIND) return(1); // BEHIND FRONT FRONT
	else return(4); // FRONT BEHIND BEHIND
   }
  }    // P1 a P3 su na opacnych stranach deliacej roviny
  else if ((side1!=side3)&&(side2==POINTPOS_ON)) {
	    // deliaca rovina prechadza vrcholom P2 povodneho trojuholnika
	    IP2=P2;
	  
	    // vypocet novych texturovacich suradnic   
        my_math.ComputeTextureCoords(P1,P2,P3,TT1,TT2,TT3,3,1,IP1,IP2,&IP1T,&IP2T);

	    // P1,P2,IP1 budu vrcholy 1. noveho trojuholnika
	    triangle_insert(split1,
	                    tri->id,
	                    tri->tex_id,
	                    P1.x,P1.y,P1.z,
	                    P2.x,P2.y,P2.z,
	                    IP1.x,IP1.y,IP1.z,
	                    tri->xt1,tri->yt1,
	                    tri->xt2,tri->yt2,
	                    IP1T.x,IP1T.y,
	                    tri->collision_tested);
	    // IP1,P2,P3 budu vrcholy 2. noveho trojuholnika
        triangle_insert(split2,
	                    tri->id,
	                    tri->tex_id,
	                    IP1.x,IP1.y,IP1.z,
	                    P2.x,P2.y,P2.z,
	                    P3.x,P3.y,P3.z,
	                    IP1T.x,IP1T.y,
	                    tri->xt2,tri->yt2,
	                    tri->xt3,tri->yt3,
	                    tri->collision_tested);
	    // vzniknu iba 2 nove trojuholniky
	    split3=NULL;

        if (side1==POINTPOS_BEHIND) return(2); // BEHIND FRONT
		else return(5); // FRONT BEHIND
       }    // P1 a P3 su na opacnych stranach deliacej roviny
       else if ((side1!=side3)&&(side2==side1)) {
		     // deliaca rovina pretina P2->P3 hranu povodneho trojuholnika
             if (my_math.EdgePlaneIntersection(P2,P3,PN,plane->D,&IP2)) {
				 
			  // vypocet novych texturovacich suradnic   
              my_math.ComputeTextureCoords(P1,P2,P3,TT1,TT2,TT3,3,2,IP1,IP2,&IP1T,&IP2T);
				 
	          // IP1,P1,P2 budu vrcholy 1. noveho trojuholnika
              triangle_insert(split1,
	                          tri->id,
	                          tri->tex_id,
	                          IP1.x,IP1.y,IP1.z,
	                          P1.x,P1.y,P1.z,
	                          P2.x,P2.y,P2.z,
	                          IP1T.x,IP1T.y,
	                          tri->xt1,tri->yt1,
	                          tri->xt2,tri->yt2,
	                          tri->collision_tested);
	          // IP1,P2,IP2 budu vrcholy 2. noveho trojuholnika
              triangle_insert(split2,
	                          tri->id,
	                          tri->tex_id,
	                          IP1.x,IP1.y,IP1.z,
	                          P2.x,P2.y,P2.z,
	                          IP2.x,IP2.y,IP2.z,
	                          IP1T.x,IP1T.y,
	                          tri->xt2,tri->yt2,
	                          IP2T.x,IP2T.y,
	                          tri->collision_tested);
	          // IP1,IP2,P3 budu vrcholy 3. noveho trojuholnika
              triangle_insert(split3,
	                          tri->id,
	                          tri->tex_id,
	                          IP1.x,IP1.y,IP1.z,
	                          IP2.x,IP2.y,IP2.z,
	                          P3.x,P3.y,P3.z,
	                          IP1T.x,IP1T.y,
	                          IP2T.x,IP2T.y,
	                          tri->xt3,tri->yt3,
	                          tri->collision_tested);
							  
              if (side1==POINTPOS_BEHIND) return(0); // BEHIND BEHIND FRONT
	          else return(3); // FRONT FRONT BEHIND
             }
		    }
 }
 
 return(6); // ERROR!!!
}

// vykreslenie BSP - rekurzivna funkcia!!! *********************************
int mTriangle::DrawSLNBSPT(_SolidLeafNode *node)
{
 // zvysi sa pocet testovanych uzlov
 tested_nodes++;

 // PN - normala trojuholnika
 PN.x=node->splitter->tr_nx; PN.y=node->splitter->tr_ny; PN.z=node->splitter->tr_nz;
 // poloha kamery voci trojuholniku
 side1=my_math.ClassifyPoint(PN,node->splitter->D,cam_pos);

 if (draw_type==1) {
  // ak je kamera pred trojuholnikom, trojuholnik sa vykresli
  // draw_type=1 znamena, ze sa kreslia len tie trojuholniky,
  // s ktorymi sa neskor bude vykonavat detekcia kolizie,
  // vsetky ostatne trojuholniky su z detekcie vylucene
  if (side1==POINTPOS_FRONT) {
   if (node->splitter->tex_id!=111) { // tex_id=111 - objekt sa nekresli
    if (node->splitter->tex_id!=last_tex_id) {
     last_tex_id=node->splitter->tex_id;
     // pokial doslo k zmene textury - pripojenie novej textury
     glBindTexture(GL_TEXTURE_2D,tri_texture.texture_id[last_tex_id]);
    }

    glColor4fv(node->splitter->color);

    glBegin(GL_TRIANGLES); // trojuholnik
     glTexCoord2f(node->splitter->xt1,node->splitter->yt1);
     glNormal3f(node->splitter->xn1,node->splitter->yn1,node->splitter->zn1);
     glVertex3f(node->splitter->x1,node->splitter->y1,node->splitter->z1);
	   
     glTexCoord2f(node->splitter->xt2,node->splitter->yt2);
     glNormal3f(node->splitter->xn2,node->splitter->yn2,node->splitter->zn2);
     glVertex3f(node->splitter->x2,node->splitter->y2,node->splitter->z2);

     glTexCoord2f(node->splitter->xt3,node->splitter->yt3);
     glNormal3f(node->splitter->xn3,node->splitter->yn3,node->splitter->zn3);
     glVertex3f(node->splitter->x3,node->splitter->y3,node->splitter->z3);
    glEnd();
   }
 
   // rekurzia pokracuje v smere "prednych" potomkov
   if (node->front!=NULL) DrawSLNBSPT(node->front);
	 
   return(0);
  }

 }
 else {
  if (node->splitter->tex_id!=111) { // tex_id=111 - objekt sa nekresli
   if (node->splitter->tex_id!=last_tex_id) {
    last_tex_id=node->splitter->tex_id;
    // pokial doslo k zmene textury - pripojenie novej textury
    glBindTexture(GL_TEXTURE_2D,tri_texture.texture_id[last_tex_id]);
   }

   glColor4f(1.0f,1.0f,1.0f,1.0f);

   glBegin(GL_TRIANGLES); // trojuholnik
    glTexCoord2f(node->splitter->xt1,node->splitter->yt1);
    glNormal3f(node->splitter->xn1,node->splitter->yn1,node->splitter->zn1);
    glVertex3f(node->splitter->x1,node->splitter->y1,node->splitter->z1);
	   
    glTexCoord2f(node->splitter->xt2,node->splitter->yt2);
    glNormal3f(node->splitter->xn2,node->splitter->yn2,node->splitter->zn2);
    glVertex3f(node->splitter->x2,node->splitter->y2,node->splitter->z2);

    glTexCoord2f(node->splitter->xt3,node->splitter->yt3);
    glNormal3f(node->splitter->xn3,node->splitter->yn3,node->splitter->zn3);
    glVertex3f(node->splitter->x3,node->splitter->y3,node->splitter->z3);
   glEnd();
  }

  // rekurzia pokracuje v smere "prednych" potomkov
  if (node->front!=NULL) DrawSLNBSPT(node->front);
 }

 // rekurzia pokracuje v smere "zadnych" potomkov
 if (node->behind!=NULL) DrawSLNBSPT(node->behind);

 return(0);
}
